#import <objc/Object.h>
#import <stdio.h>
@interface Something : Object
{
	int x;
}
-init;
-(void)incrementByNumber:(int)num ifSmallerThan:(int)small;
-(char*)provideString;
// @property (assign) int x;
@end

@implementation Something
-init
{
	if(self=[super init])
	{
		printf("Yay!\n");
		x = 6;
		// [self incrementByNumber:1 ifSmallerThan:30];
	}
	return self;
}
-(void)incrementByNumber:(int)num ifSmallerThan:(int)small
{
	if(x < small)
		x += 6;
}
-(char*)provideString
{
	return "Hello from ObjC JNI!";
}
// @synthesize x;
@end

int objc_main(){
	Something *s = [[Something alloc] init]; 
	[s incrementByNumber:5 ifSmallerThan:30];
	//printf("X is %d\n", s.x);
	return [s provideString];
}

#include <string.h>
#include <jni.h>

/* This is a trivial JNI example where we use a native method
 * to return a new VM String. See the corresponding Java source
 * file located at:
 *
 *   src/com/example/HelloObjcJni/HelloObjcJni.java
 */
jstring
Java_com_example_helloobjcjni_HelloObjcJni_stringFromJNI( JNIEnv* env,
                                                 jobject thiz )
{
    char* aString = objc_main(); /* just test calling ObjC code */
    return (*env)->NewStringUTF(env, aString);
}
